Syncfusion Feedback

Trusted by the world’s leading companies

Syncfusion Trusted Companies

Overview

The React TreeGrid is a feature-rich control used to visualize self-referential, hierarchical data effectively in a tabular format (a tree-like structure). Its rich feature set includes many functionalities: data binding, virtualization, editing, sorting, searching, filtering, infinite scrolling, paging, frozen rows and columns, exporting to multiple formats, aggregating rows, and more.


Why choose Syncfusion Essential Studio® React Tree Grid?

A high performance React Tree Grid.

High performance

Display data hierarchically, its optimized design provides high performance and load millions of records in just a few seconds.

React Tree Grid with seamless data binding.

Seamless data binding

Bind data seamlessly with various local and remote data sources such as JSON, OData, WCF, and RESTful web services with the help of a data manager.

React Tree Grid hierarchical grid.

Self-referential, hierarchical grid

React Tree Grid is designed to visualize self-referential and hierarchical in a tabular format. This in turns displays the relationship between parent and child records.

React Tree Grid with flexible editing.

Flexible editing

The React Tree Grid performs create, read, update, and delete operations (CRUD) with observable data. It edits with an Array of JSON or remote data service with the data manager.

Responsive React Tree Grid.

Adapts to any resolution

The Tree Grid has a highly responsive layout and an optimized design for desktops, touch screens, and smart phones. It works well on all mobile phones that use iOS, Android, or Windows OS.

Create your own template designs in React Tree Grid.

Create your own template designs

Using templates, users can create a custom UI in the React Tree Grid based on their application need using a wide range of template options.

React Tree Grid with customizable themes.

Attractive customizable themes

Cutting edge design with 5+ built-in themes such as Fluent, Tailwind CSS, Bootstrap, Material, Fabric, and more. Utilize the online Theme Studio tool to customize themes of Tree Grid easily.

Globalization and localization in React Tree Grid.

Globalization and localization

Enables users from different locales to use the Tree Grid by formatting dates, currency, and numbering to suit their preferences.


React TreeGrid Code Example

Easily get started with the React TreeGrid using a few simple lines of TSX code example as demonstrated below. Also explore our React TreeGrid Example that shows you how to render and configure a TreeGrid in React.

  1. import { ColumnDirective, ColumnsDirective, TreeGridComponent } from '@syncfusion/ej2-react-treegrid';
  2. import * as React from 'react';
  3. import { sortData } from './data';
  4. function App() {
  5. return <TreeGridComponent dataSource={sortData} treeColumnIndex={1} childMapping='subtasks'>
  6. <ColumnsDirective>
  7. <ColumnDirective field='Category' headerText='Category' width='150'/>
  8. <ColumnDirective field='orderName' headerText='Order Name' width='170'/>
  9. <ColumnDirective field='orderDate' headerText='Order Date' width='130' format='yMd' textAlign='Right' type='date' />
  10. <ColumnDirective field='price' headerText='Price' width='100' textAlign='Right' type='number' format='C0' />
  11. </ColumnsDirective>
  12. </TreeGridComponent>
  13. };
  14. export default App;

React Tree Grid skeleton loading indicator.

Skeleton loading indicator

The Tree Grid shows the shimmer effect as a loading indicator while fetching data and binding it to the tree grid during initial rendering, refreshing, or after performing grid actions like sorting, filtering, and more. The Tree Grid offers two types of effects, spinner and shimmer.


Column

Columns define the schema of a data source in React Tree Grid. Features include formatting, column definitions, text wrapping, column chooser, column menu, column reordering, and other important features.

React Tree Grid column.


React Tree Grid paging.

Paging

Through paging, a segment of data can be viewed from the assigned data source. The React Tree Grid offers built-in pager UI with options to customize its entire UI. It also has an on-demand paging mode for effective data retrieval from remote web services.


Sorting

The React Tree Grid allows users to sort a column by simply clicking on the header. A Ctrl + header click performs multi-sorting. Sort data in either ascending or descending order.

React Tree Grid sorting.


React Tree Grid filtering.

Filtering

Filtering helps view specific or related records that meet a given filtering criteria. It supports various filter types that include powerful Excel-like filter. The React Tree Grid filter allows users to choose appropriate filter types, define their own custom filtering logic, and customize the filtering UI based on their application needs. Filtering with related parent or child records can be defined.


Selection

React TreeGrid allows selecting rows or cells. One or more rows or cells can also be selected by holding Ctrl or Command, or programmatically.

React Tree Grid cell selection.


Rows in React Tree Grid.

Row

Rows in Tree Grid represents each data object information from the data source. It supports expanding / collapsing child rows, reordering of rows, indent / outdent rows to change its hierarchy levels and much more features.


Editing

The React TreeGrid provides full support to create, read, update, and delete operations (CRUD). In addition to built-in editor components to edit a particular column value, using template support users can create custom editor components that suit their application needs. It performs editing operations with JSON collection or remote data service with the help of data manager.

React TreeGrid editing.


React TreeGrid row drag and drop.

Row drag and drop

The React TreeGrid allows users to drag and drop rows within the same or another tree grid. This functionality is especially useful for reorganizing data and creating a more intuitive user experience.


Aggregation

Aggregates for column values can easily be displayed using the aggregate feature. Aggregates can be customized to show their value in every hierarchy with a set of predefined summary types.

Aggregation in React TreeGrid.


React TreeGrid with freeze columns.

Frozen columns

Frozen columns are visible at the left or right or both the sides of the tree grid and make the remaining grid content scrollable. It is mainly used to compare cell values.


You can search the records using the search method. Integrate search text box in the React TreeGrid’s toolbar by adding search items.

React TreeGrid with search.


React TreeGrid adaptive UI layout.

Adaptive UI layout

The React Tree Grid user interface is customized and redesigned for great views and usability on small screens. Filter, search, and edit dialogs are adaptive to the screen size.


Custom tooltip

React TreeGrid component allows you to set tooltips for treegrid cells. Hover over the tree nodes to display tooltip text.

React TreeGrid with tooltip.


Exporting

Export to PDF, CSV, and Excel formats in React Tree Grid.

Excel, PDF, CSV export

Easily export the React Tree Grid control in various file formats such as Excel, PDF, or CSV. Users can also programmatically customize the exported document.

Print React Tree Grid content.

Print

Users can print data either by using the print option from the toolbar or programmatically. Print all the rows of a React TreeGrid regardless of the number of pages or print the currently viewed page alone.


Additional features

React TreeGrid with custom row height.

Row height

Row height is a major factor when displaying the number of records in the view port, and it is effortlessly customizable based on the application’s UI requirement. It is also possible to set row height conditionally.

Copy to clipboard from React TreeGrid.

Copy to clipboard

The clipboard provides an option to copy selected rows or cells’ data into the clipboard. Use Ctrl+C and Ctrl+Shift+H key combinations to copy data with and without headers, respectively.

React TreeGrid with context menu.

Context menu

The context menu improves user action with React Tree Grid using popup menu. It appears when the cell, header, or pager is right clicked. In addition to built-in default menu items, it allows you to add custom context menu items.

Width and height in React TreeGrid.

Width and height

Allows changing the React Tree Grid size by setting the width and height properties. Horizontal and vertical scrollbars will appear when the content overflows the React Tree Grid element. For the React Tree Grid to fill its parent container, the user must simply set the height and width to 100%.

React TreeGrid with stacked headers.

Stacked headers

Stacked headers allow grouping and visualizing column headers in a stacked manner. There is no limit to the number of columns that can be stacked. Allows the user to perform all React TreeGrid actions, even when the columns are stacked.


Accessibility

Keyboard navigation in React TreeGrid.

Keyboard navigation

The Tree Grid ensures that every cell is keyboard accessible. Major features like expanding or collapsing child rows, sort, select, and edit can be performed using keyboard commands alone; no mouse interaction required. This helps in creating highly accessible applications using this component.

Accessibility and screen reader support in React Tree Grid.

Screen reader

The React Tree Grid has complete WAI-ARIA accessibility support. Its UI includes high-contrast visual elements, helping visually impaired people have the best viewing experience. Also, the valid UI descriptions are easily accessible through assistive technologies such as screen readers.

Show right-to-left language in React Tree Grid.

Right to left (RTL)

Right-to-left rendering allows displaying the text and layout of the React Tree Grid from right to left. This improves the user experience and accessibility for RTL languages.

Other supported frameworks

The Tree Grid component is available for the Blazor, Angular, JavaScript, and Vue frameworks. Explore its platform-specific options through the following links:

Supported browsers

The React Tree Grid works well with all modern web browsers, including Chrome, Firefox, Edge, Safari, and Opera.

Supported browsers in React Tree Grid.

90+ REACT UI COMPONENTS

Frequently Asked Questions

The Syncfusion React Tree Grid provides the following features:

  • Load large amounts of data by dynamically loading child data on demand.
  • Include flexible UI interactions like expanding and collapsing parent records, dialog editing, and more.
  • Flexible data binding with support to use local and remote data sources such as JSON, RESTful services, OData services, and WCF services.
  • One of the best React Tree Grid in the market that offers feature-rich UI to interact with the software.
  • Attractive UI appearance with built-in themes such as fabric, bootstrap, etc.
  • Simple configuration and API.
  • Supports all modern browsers.
  • Mobile-touch friendly and responsive.
  • Expansive learning resources such as demos and documentation to learn quickly and get started with React Tree Grid.

We do not sell the React Tree Grid separately. It is only available for purchase as part of the Syncfusion team license. This contains over 1,900 components and frameworks, including the React Tree Grid. The price of the team license starts at $395 per month for 5 developers, and includes support and updates until the subscription expires. In addition, we might offer discounts based on currently active promotions. Please contact our product specialists today to see if you qualify for any additional discounts.

You can find our React TreeGrid demo, which demonstrates how to render and configure the TreeGrid.

No, our 1,900+ components and frameworks for web, mobile, and desktop, including our React Tree Grid, are not sold individually. They are only available as part of a team license. However, we have competitively priced the product, so it only costs a little bit more than what some other vendors charge for their Tree Grid component alone. We have also found that, in our experience, our customers usually start off using one of our products and then expand to several products quickly, so we felt it was best to offer all 1,900+ components and frameworks for a subscription fee that starts at $395 per month for a team of 5 developers. Additionally, we might be able to offer discounts based on currently active promotions. Please contact our product specialists today to see if you qualify for any additional discounts.

No, this is a commercial product and requires a paid license. However, a free community license is also available for companies and individuals whose organizations have less than $1 million USD in annual gross revenue, 5 or fewer developers, and 10 or fewer total employees.

A good place to start would be our comprehensive getting started documentation.

Our Customers Love Us

Having an excellent set of tools and a great support team, Syncfusion® reduces customers’ development time.
Here are some of their experiences.

Rated by users across the globe

Transform your applications today by downloading our free evaluation version
Download Free Trial No credit card required.

Awards

Greatness—it’s one thing to say you have it, but it means more when others recognize it. Syncfusion® is proud to hold the following industry awards.

Up arrow icon
Chat with us

Syncfusion Feedback

Trusted by the world’s leading companies

syncfusion trusted companies

Overview

The Angular TreeGrid is a feature-rich control used to visualize self-referential, hierarchical data effectively in a tabular format (a tree-like structure). Its rich feature set includes many functionalities: data binding, virtualization, editing, sorting, searching, filtering, infinite scrolling, paging, frozen rows and columns, exporting to multiple formats, aggregating rows, and more.


Why choose Syncfusion Essential Studio® Angular Tree Grid?

High performance

Display data hierarchically, its optimized design provides high performance and load millions of records in just a few seconds.

Seamless data binding

Bind data seamlessly with various local and remote data sources such as JSON, OData, WCF, and RESTful web services with the help of a data manager.

Self-referential, hierarchical grid

Angular TreeGrid is designed to visualize self-referential and hierarchical in a tabular format. This in turns displays the relationship between parent and child records.

Flexible editing

The Angular Tree Grid performs create, read, update, and delete operations (CRUD) with observable data. It edits with an Array of JSON or remote data service with the data manager.

Adapts to any resolution

The Tree Grid has a highly responsive layout and an optimized design for desktops, touch screens, and smart phones. It works well on all mobile phones that use iOS, Android, or Windows OS.

Create your own template designs

Using templates, users can create a custom UI in the Angular Tree Grid based on their application need using a wide range of template options.

Attractive customizable themes

Cutting edge design with 5+ built-in themes such as Fluent, Tailwind CSS, Bootstrap, Material, Fabric, and more. Utilize the online Theme Studio tool to customize themes of Angular Tree Grid easily.

Globalization and localization

Enables users from different locales to use the Tree Grid by formatting dates, currency, and numbering to suit their preferences.


Angular Tree Grid Code Example

Easily get started with the Angular Tree Grid (Tree Table) using a few simple lines of HTML and TS code example as demonstrated below. Also explore our Angular Tree Grid Example that shows you how to render and configure a Tree Grid in Angular.

  1. <ejs-treegrid [dataSource]='data' [treeColumnIndex]='1' height='350' childMapping='subtasks'>
  2. <e-columns>
  3. <e-column field='taskID' headerText='Task ID' textAlign='Right' width=90></e-column>
  4. <e-column field='taskName' headerText='Task Name' textAlign='Left' width=180></e-column>
  5. <e-column field='startDate' headerText='Start Date' textAlign='Right' format='yMd' width=90><e-column>
  6. <e-column field='duration' headerText='Duration' textAlign='Right' width=80></e-column>
  7. </e-columns>
  8. </ejs-treegrid>
  1. import { Component, OnInit } from '@angular/core';
  2. import { sampleData } from './datasource';
  3.  
  4. @Component({
  5.     selector: 'ej2-treegrid-container',
  6.     templateUrl: 'default.html'
  7. })
  8. export class DefaultComponent implements OnInit {
  9.     public data: Object[] = [];
  10.  
  11.     ngOnInit(): void {
  12.         this.data = sampleData;
  13.     }
  14. }

Skeleton loading indicator

The Tree Grid shows the shimmer effect as a loading indicator while fetching data and binding it to the tree grid during initial rendering, refreshing, or after performing grid actions like sorting, filtering, and more. The Tree Grid offers two types of effects, spinner and shimmer.

Angular Tree Grid with skeleton loading indicator.


Angular Tree Grid with column customization.

Column

Columns define the schema of a data source in Angular Tree Grid. Features include formatting, column definitions, text wrapping, column chooser, column menu, column reordering, and other important features.


Paging

Through paging, a segment of data can be viewed from the assigned data source. The Angular Tree Grid offers built-in pager UI with options to customize its entire UI. It also has an on-demand paging mode for effective data retrieval from remote web services.

Paging in Angular Tree Grid.


Sorting in Angular Tree Grid.

Sorting

The Angular Tree Grid allows users to sort a column by simply clicking on the header. A Ctrl + header click performs multi-sorting. Sort data in either ascending or descending order.


Filtering

Filtering helps view specific or related records that meet a given filtering criteria. It supports various filter types that include powerful Excel-like filter. The Angular Tree Grid filter allows users to choose appropriate filter types, define their own custom filtering logic, and customize the filtering UI based on their application needs. Filtering with related parent or child records can be defined.

Filtering in Angular Tree Grid.


Selection in Angular Tree Grid Cell.

Selection

Angular Tree Grid allows selecting rows or cells. One or more rows or cells can also be selected by holding Ctrl or Command, or programmatically.


Angular TreeGrid Editing.

Editing

The Angular TreeGrid provides full support to create, read, update, and delete operations (CRUD). In addition to built-in editor components to edit a particular column value, using template support users can create custom editor components that suit their application needs. It performs editing operations with JSON collection or remote data service with the help of data manager.


Row drag and drop

The Angular TreeGrid allows users to drag and drop rows within the same or another tree grid. This functionality is especially useful for reorganizing data and creating a more intuitive user experience.

Angular TreeGrid row drag and drop.


Angular TreeGrid with aggregation.

Aggregation

Aggregates for column values can easily be displayed using the aggregate feature. Aggregates can be customized to show their value in every hierarchy with a set of predefined summary types.


Frozen columns

Frozen columns are visible at the left or right or both the sides of the Angular Tree Grid and make the remaining grid content scrollable. It is mainly used to compare cell values.


Angular TreeGrid with search option.

You can search the records using the search method. Integrate search text box in the Angular TreeGrid’s toolbar by adding search items.


Custom tooltip

Angular TreeGrid component allows you to set tooltips for treegrid cells. Hover over the tree nodes to display tooltip text.

Angular TreeGrid with tooltip.


Exporting

Export to PDF, CSV, and Excel formats in Angular Tree Grid.

Excel, PDF, CSV export

Easily export the HTML5 Tree Grid control in various file formats such as Excel, PDF, or CSV. Users can also programmatically customize the exported document.

Print Angular Tree Grid content.

Print

Users can print data either by using the print option from the toolbar or programmatically. Print all the rows of a Angular Tree Grid regardless of the number of pages or print the currently viewed page alone.


Additional features

Angular TreeGrid with row height.

Row height

Row height is a major factor when displaying the number of records in the view port, and it is effortlessly customizable based on the application’s UI requirement. It is also possible to set row height conditionally.

Copy to clipboard from Angular TreeGrid.

Copy to clipboard

The clipboard provides an option to copy selected rows or cells’ data into the clipboard. Use Ctrl+C and Ctrl+Shift+H key combinations to copy data with and without headers, respectively.

Angular TreeGrid with context menu.

Context menu

The context menu improves user action with Angular Tree Grid using popup menu. It appears when the cell, header, or pager is right clicked. In addition to built-in default menu items, it allows you to add custom context menu items.

Width and height in Angular TreeGrid.

Width and height

Allows changing the Angular Tree Grid size by setting the width and height properties. Horizontal and vertical scrollbars will appear when the content overflows the Angular Tree Grid element. For the Angular Tree Grid to fill its parent container, the user must simply set the height and width to 100%.

Angular TreeGrid with stacked headers.

Stacked headers

Stacked headers allow grouping and visualizing column headers in a stacked manner. There is no limit to the number of columns that can be stacked. Allows the user to perform all Angular TreeGrid actions, even when the columns are stacked.


Accessibility

Keyboard navigation in Angular TreeGrid.

Keyboard navigation

The Tree Grid ensures that every cell is keyboard accessible. Major features like expanding or collapsing child rows, sort, select, and edit can be performed using keyboard commands alone; no mouse interaction required. This helps in creating highly accessible applications using this component.

Accessibility and screen reader support in Angular Tree Grid.

Screen reader

The Angular Tree Grid has complete WAI-ARIA accessibility support. Its UI includes high-contrast visual elements, helping visually impaired people have the best viewing experience. Also, the valid UI descriptions are easily accessible through assistive technologies such as screen readers.

Show right-to-left language in Angular Tree Grid.

Right to left (RTL)

Right-to-left rendering allows displaying the text and layout of the Angular Tree Grid from right to left. This improves the user experience and accessibility for RTL languages.


Angular version compatibility

With continuous improvement in Angular versions, the Angular Tree Grid is kept up to date to make it compatible with versions starting from 4 to the latest version.

Angular Tree Grid version compatibility.

Struggling to decide on the right product?

Our comprehensive competitor comparison of Angular components will guide you to the perfect choice.

tick-mark Hierarchical data binding
tick-mark 60+ interactive demos
tick-mark 925K+ downloads
competitive-banner-FT-image

Other supported frameworks

The Tree Grid is available for the Blazor, React, JavaScript, and Vue frameworks. Explore its platform-specific options through the following links:

Supported browsers

The Angular Tree Grid works well with all modern web browsers, including Chrome, Firefox, Edge, Safari, and Opera.

Supported browsers in Angular Tree Grid.

90+ ANGULAR UI COMPONENTS

Frequently Asked Questions

  • Load large amounts of data by dynamically loading child data on demand.
  • Include flexible UI interactions like expanding and collapsing parent records, dialog editing, and more.
  • Flexible data binding with support to use local and remote data sources such as JSON, RESTful services, OData services, and WCF services.
  • One of the best Angular Tree Grid in the market that offers feature-rich UI to interact with the software.
  • Attractive UI appearance with built-in themes such as fabric, bootstrap, etc.
  • Simple configuration and API.
  • Supports all modern browsers.
  • Mobile-touch friendly and responsive.
  • Expansive learning resources such as demos, documentation and videos to learn quickly and get started with Angular Tree Grid.

We do not sell the Angular Tree Grid separately. It is only available for purchase as part of the Syncfusion team license. This contains over 1,900 components and frameworks, including the Angular Tree Grid. The price of the team license starts at $395 per month for 5 developers, and includes support and updates until the subscription expires. In addition, we might offer discounts based on currently active promotions. Please contact our product specialists today to see if you qualify for any additional discounts.

You can find our Angular Tree Grid demo, which demonstrates how to render and configure the TreeGrid.

No, our 1,900+ components and frameworks for web, mobile, and desktop, including our Angular Tree Grid, are not sold individually. They are only available as part of a team license. However, we have competitively priced the product, so it only costs a little bit more than what some other vendors charge for their Tree Grid component alone. We have also found that, in our experience, our customers usually start off using one of our products and then expand to several products quickly, so we felt it was best to offer all 1,900+ components and frameworks for a subscription fee that starts at $395 per month for a team of 5 developers. Additionally, we might be able to offer discounts based on currently active promotions. Please contact our product specialists today to see if you qualify for any additional discounts.

No, this is a commercial product and requires a paid license. However, a free community license is also available for companies and individuals whose organizations have less than $1 million USD in annual gross revenue, 5 or fewer developers, and 10 or fewer total employees.

A good place to start would be our comprehensive getting started documentation.

Our Customers Love Us

Having an excellent set of tools and a great support team, Syncfusion® reduces customers’ development time.
Here are some of their experiences.

Rated by users across the globe

Transform your applications today by downloading our free evaluation version
Download Free Trial No credit card required.

Awards

Greatness—it’s one thing to say you have it, but it means more when others recognize it. Syncfusion® is proud to hold the following industry awards.

Up arrow icon
Chat with us